package org.rcisoft.business.bbanner.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;

import org.rcisoft.core.entity.IdEntity;
import org.rcisoft.sys.dept.entity.SysDept;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;


/**
 * @author
 * @date 2019/9/10
 */
@Entity
@Table(name = "b_banner")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BBanner extends IdEntity<BBanner> {

    private static final long serialVersionUID = 8683139175568024924L;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    @ApiModelProperty(value = "标题")
    private String title;

    @Length(min = 1,max = 128,message = "长度最小为1,最大为256")
    @NotBlank(message="图片不能为空")
    @ApiModelProperty(value = "图片地址")
    private String imageUrl;

    @Length(min = 1,max = 1,message = "长度最小为1,最大为1")
    @NotBlank
    @ApiModelProperty(value = "是否为外部链接（0：否，1：是）")
    private String isExternalLink;

    @ApiModelProperty(value = "外部URL")
    private String externalUrl;

    @Length(min = 1,max = 1,message = "长度最小为1,最大为1")
    @ApiModelProperty(value = "类型（0：线下，1：线上）")
    private String lineType;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @ApiModelProperty(value = "课程ID")
    private String courseId;

    @ApiModelProperty(value = "排序")
    private Integer bannerSort;

    @ApiModelProperty(value = "是否为平台推送")
    private String isPush;

    @ApiModelProperty(value = "推送源数据主键id")
    private String supperId;

    @ApiModelProperty(value = "课程名")
    @Transient
    private String lessonName;

    @ApiModelProperty(value = "课程封面")
    @Transient
    private String lessonDefaultUrl;
}