package org.rcisoft.business.bchapter.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.rcisoft.business.bchapter.dao.BChapterRepository;
import org.rcisoft.business.bchapter.entity.BChapter;

import java.util.List;

@Data
public class QueryChapterListResDTO {
    @ApiModelProperty(value = "章节名")
    private String chapterName;

    @ApiModelProperty(value = "章节类型  1章 2 节")
    private String chapterLevel;

    @ApiModelProperty(value = "上一级")
    private String pid;

    @ApiModelProperty(value = "课程地址")
    private String chapterUrl;

    @ApiModelProperty(value = "课件类型 0视频 1音频 2PPT 3PDF 4文件包")
    private String isTest;

    @ApiModelProperty(value = "课程ID")
    private String lessonId;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @ApiModelProperty(value = "上一级的序号")
    private Integer pSort;

    @ApiModelProperty(value = "子章节")
//    private List<BChapter> childList;
    private List<QueryChapterListResDTO> childList;

    @ApiModelProperty(value = "视频地址")
    private String videoUrl;

    @ApiModelProperty(value = "文件大小")
    private String fileSize;

    @ApiModelProperty(value = "文件地址")
    private String fileUrl;

    @ApiModelProperty(value = "章节是否完成 0未完成 1完成")
    private String isComplete;

    @ApiModelProperty(value = "文件名")
    private String fileName;

    @ApiModelProperty(value = "进度")
    private String progress;

    @ApiModelProperty(value = "最近进度")
    private int currentLocation;

    @ApiModelProperty(value = "id")
    private String businessId;

    @ApiModelProperty(value = "id")
    private String corpId;

    @ApiModelProperty(value = "b_lesson_person_id")
    private String BLPBusinessId;

    @ApiModelProperty(value = "b_r_student_chapter_id")
    private String BRSBusinessId;

    @ApiModelProperty(value = "课程时间")
    private String courseTime;

    @ApiModelProperty(value = "是否是切割的节")
    private String isCutPdf;
}
