package org.rcisoft.business.bchapter.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.bchapter.dao.BPChapterRepository;
import org.rcisoft.business.bchapter.entity.BPChapter;
import org.rcisoft.business.bchapter.service.BPChapterService;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by  on 2020-7-1 18:57:28.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BPChapterServiceImpl implements BPChapterService {

    @Autowired
    private BPChapterRepository bPChapterRepository;


    /**
    * 保存 平台记录企业课程章节表
    * @param bPChapter
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(BPChapter bPChapter){
        //增加操作
        UserUtil.setCurrentPersistOperation(bPChapter);
        int line = bPChapterRepository.insertSelective(bPChapter);
        return new PersistModel(line);
    }

    /**
    * 删除 平台记录企业课程章节表
    * @param bPChapter
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel remove(BPChapter bPChapter){
        int line = bPChapterRepository.deleteByPrimaryKey(bPChapter.getBusinessId());
        return new PersistModel(line);
    }




}
