package org.rcisoft.business.bdefaultpic.controller;


/*固定导入*/

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.common.model.GridModel;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.exception.ServiceException;

import javax.validation.Valid;


import org.rcisoft.business.bdefaultpic.entity.BDefaultPic;
import org.rcisoft.business.bdefaultpic.service.BDefaultPicService;

import java.util.List;

/**
 * Created by  on 2019-11-26 14:44:48.
 */
@Api(tags = "17 图片管理")
@RestController
@RequestMapping("bdefaultpic")
public class BDefaultPicController extends PaginationController<BDefaultPic> {

    @Autowired
    private BDefaultPicService bDefaultPicServiceImpl;


    @ApiOperation(value = "1701 添加", notes = "添加")
    @ApiImplicitParams({@ApiImplicitParam(name = "pic", value = "默认图片链接", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(CurUser curUser, String pic) {
        PersistModel data = bDefaultPicServiceImpl.save(pic);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                pic);
    }

    @ApiOperation(value = "1702 逻辑删除", notes = "逻辑删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "主键id", required = false, dataType = "varchar")})
    @DeleteMapping("/delete")
    public Result delete(CurUser curUser, String businessId) {
        BDefaultPic bDefaultPic = new BDefaultPic();
        bDefaultPic.setBusinessId(businessId);
        PersistModel data = bDefaultPicServiceImpl.remove(bDefaultPic);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                businessId);
    }

    @ApiOperation(value = "1703 分页查询默认图片列表", notes = "查看  集合")
    @GetMapping(value = "/queryBDefaultPicByPagination")
    public GridModel listByPagination(CurUser curUser) {
        bDefaultPicServiceImpl.findAllByPagination(getPaginationUtility(), curUser);
        return getGridModelResponse();
    }
//    public Result listByPagination(CurUser curUser) {
//        bDefaultPicServiceImpl.findAllByPagination(getPaginationUtility(), curUser);
//        GridModel gridModel = getGridModelResponse();
//        return Result.builder(new PersistModel(1),
//                MessageConstant.MESSAGE_ALERT_SUCCESS,
//                MessageConstant.MESSAGE_ALERT_ERROR,
//                gridModel);
//    }

    @ApiOperation(value = "1704 查询默认图片列表", notes = "查看  集合")
    @GetMapping(value = "/queryBDefaultPic")
    public Result queryList(CurUser curUser) {
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                bDefaultPicServiceImpl.findAll(curUser));
    }
}
