package org.rcisoft.business.blesson.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;


import org.rcisoft.business.blesson.entity.BPLesson;
import org.rcisoft.business.blesson.service.BPLessonService;

/**
* Created by  on 2020-7-1 18:57:28.
*/
@RestController
@RequestMapping("/bplesson")
public class BPLessonController extends PaginationController<BPLesson> {

    @Autowired
    private BPLessonService bPLessonServiceImpl;


    @ApiOperation(value="添加平台记录企业的课程", notes="添加平台记录企业的课程")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(@Valid BPLesson bPLesson, BindingResult bindingResult) {
        PersistModel data = bPLessonServiceImpl.save(bPLesson);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        bPLesson);
    }

    @ApiOperation(value="删除平台记录企业的课程", notes="删除平台记录企业的课程")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public Result delete(@PathVariable String businessId,BPLesson bPLesson) {
        bPLesson.setBusinessId(businessId);
        PersistModel data = bPLessonServiceImpl.remove(bPLesson);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        businessId);
    }

}
