package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.business.blesson.entity.BPLesson;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2020-7-1 18:57:28.
*/
@Repository
public interface BPLessonRepository extends BaseMapper<BPLesson> {

    /**
    * 分页查询 bPLesson
    *
    */
    @Select("<script>select * from b_p_lesson where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BPLesson> queryBPLessons(BPLesson bPLesson);


    @Insert("<script>" +
            " insert into b_p_lesson VALUES " +
            "<foreach collection=\"list\" item=\"item\" index=\"index\" separator=\",\"> " +
            "(#{item.businessId}, #{item.code}, #{item.lessonName},#{item.defaultUrl}, #{item.createBy}, #{item.updateBy}, " +
            "#{item.delFlag}, #{item.flag}, #{item.remarks}, #{item.updateDate}, #{item.createDate}, #{item.classHour}," +
            "#{item.lecturerId}, #{item.releaseState}, #{item.courseId}, #{item.personNumber}, #{item.courseTime}, " +
            "#{item.courseDescription}, #{item.viewRange}, #{item.releaseDate}, #{item.closeDate}, #{item.lessonType}," +
            "#{item.discussNumber}, #{item.recommend}, #{item.collectNumber}, #{item.hotNumber}, #{item.corpId}, " +
            "#{item.applyStartDate}, #{item.applyOverDate}, #{item.trainStartDate}, #{item.trainOverDate}, #{item.maxApplyPerson}, " +
            "#{item.trainAddress},#{item.trainSignTime},#{item.qrCode},#{item.valueConsume},#{item.valueGain}, #{item.valueUpdateDate})" +
            "</foreach>  </script>")
    int insertList(List<BLesson> list);

    /**
     * 批量删除 课程
     * @param list
     * @return
     */
    @Delete("<script>" +
            " delete from b_p_lesson where business_id in " +
            "<foreach item='item' index='index' collection='list' open='(' separator=',' close=')'> #{item.businessId} </foreach> "+
            "</script>")
    int deleteList(List<BLesson> list);

}

