package org.rcisoft.business.blesson.util;

import org.rcisoft.business.blesson.dto.SynLessonDTO;
import org.rcisoft.business.blesson.dto.SynUserDTO;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 指派类锁，防止同时操作同一个课程
 */
public class LessonSyncUtil {


    private static Map<String, SynLessonDTO> synLessonDTOList = new HashMap<>();

    private static Map<String, SynUserDTO> synUserDTOList = new HashMap<>();


    public static SynLessonDTO getSynLessonDTO(String lessonId){
        if(synLessonDTOList.containsKey(lessonId))
            return synLessonDTOList.get(lessonId);
        SynLessonDTO synLessonDTO = new SynLessonDTO(lessonId);
        synLessonDTOList.put(lessonId,synLessonDTO);
        return synLessonDTO;
    }

    public static void removeSynLessonDTO(String lessonId){
        if(synLessonDTOList.containsKey(lessonId))
            synLessonDTOList.remove(lessonId);
    }

    public static SynUserDTO getSynUserDTO(String userId){
        if(synUserDTOList.containsKey(userId))
            return synUserDTOList.get(userId);
        SynUserDTO synUserDTO = new SynUserDTO(userId);
        synUserDTOList.put(userId,synUserDTO);
        return synUserDTO;
    }

    public static void removeSynUserDTO(String userId){
        if(synUserDTOList.containsKey(userId))
            synUserDTOList.remove(userId);
    }

}
