package org.rcisoft.business.bnotice.controller;


/*固定导入*/
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.bnotice.dto.ReadDTO;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.common.model.GridModel;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.exception.ServiceException;
import javax.validation.Valid;


import org.rcisoft.business.bnotice.entity.BNotice;
import org.rcisoft.business.bnotice.service.BNoticeService;

import java.util.List;

/**
* Created by  on 2019-11-28 11:18:34.
*/
@Api(tags = "18 通知")
@RestController
@RequestMapping("bnotice")
public class BNoticeController extends PaginationController<BNotice> {

    @Autowired
    private BNoticeService bNoticeServiceImpl;


//    @ApiOperation(value="添加", notes="添加")
//    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
//    @PostMapping(value = "/add")
//    public Result add(@Valid BNotice bNotice, BindingResult bindingResult) {
//        PersistModel data = bNoticeServiceImpl.save(bNotice);
//        return Result.builder(data,
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        bNotice);
//    }

//    @ApiOperation(value="逻辑删除", notes="逻辑删除")
//    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
//    @PostMapping("/delete/{id:\\w+}")
//    public Result delete(@PathVariable String id) {
//        BNotice bNotice = new BNotice();
//        bNotice.setBusinessId(id);
//        PersistModel data = bNoticeServiceImpl.remove(bNotice);
//        return Result.builder(data,
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        id);
//    }
//
//    @ApiOperation(value="查看单 ", notes="查看单 ")
//    @GetMapping("/detail/{id:\\w+}")
//    public Result detail(@PathVariable String id) {
//        return Result.builder(new PersistModel(1),
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        bNoticeServiceImpl.findById(id));
//    }

    @ApiOperation(value="1801条件分页查询集合", notes="条件分页查询集合")
    @GetMapping(value = "/queryBNoticeByPagination")
    public GridModel listByPagination(BNotice bNotice) {
        bNoticeServiceImpl.findAllByPagination(getPaginationUtility(), bNotice);
        return getGridModelResponse();
    }

    @ApiOperation(value="1802批量设置为已读", notes="批量设置为已读")
    @PostMapping("/setRead")
    public Result delete(CurUser curUser, @Valid ReadDTO readDTO,  BindingResult bindingResult) {
        PersistModel data = bNoticeServiceImpl.setRead(readDTO);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
                readDTO);
    }
}
