package org.rcisoft.business.bpersonvalue.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bpersonvalue.dto.PersonValueClientDto;
import org.rcisoft.business.bpersonvalue.dto.PersonValueDto;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bpersonvalue.entity.BPersonValue;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-11-13 13:28:38.
*/
@Repository
public interface BPersonValueRepository extends BaseMapper<BPersonValue> {

    /**
     * 分页查询 bPersonValue
     *
    */
    @Select("<script>" +
            "select DISTINCT T.* from (" +
            "select bpv.business_id,bpv.person_id,bpv.create_by,bpv.create_date,bpv.update_by,bpv.update_date,bpv.remarks,bpv.`value`,bpv.type , " +
            " replace(event,'!@#',lesson_name) event ,bpv.`event` ss,bl.lesson_name from b_person_value bpv\n" +
            "left join b_lesson bl on bl.business_id = bpv.lesson_id\n" +
            "where bpv.del_flag != 1 and bpv.flag = 1  and bpv.person_id = #{businessId} " +
            "<if test=\"startTime !=null and startTime != '' \"> and bpv.create_date &gt;= #{startTime} </if> "+
            "<if test=\"endTime !=null and endTime != '' \"> and bpv.create_date &lt;= date_add(#{endTime},interval 1 day) </if> "+
            "<if test=\"type !=null and type != '' \"> and bpv.type = #{type} </if> " +
            ") T where 1=1" +
            "<if test=\"event !=null and event != '' \"> and ((`event` like concat('%',#{event},'%')) or (ss like concat('%',#{event},'%')) )  </if> "+

            " ORDER BY T.person_id " +
            "<if test=\" valueSort !=null and valueSort != '' and valueSort == '1'.toString() \">  ,T.type asc,CAST(if(T.type = 0,`value`,-`value`) AS UNSIGNED) desc </if> "+
            "<if test=\" valueSort !=null and valueSort != '' and valueSort == '0'.toString() \">  ,T.type desc,CAST(if(T.type = 1,`value`,-`value`) AS UNSIGNED) desc </if> "+
            "<if test=\" dateSort !=null and dateSort != '' and dateSort == '1'.toString() \">  ,T.create_date asc</if> "+
            "<if test=\" dateSort !=null and dateSort != '' and dateSort == '0'.toString() \">  ,T.create_date desc</if> " +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BPersonValue> queryBPersonValues(PersonValueClientDto dto);


    @Select("select `value` from s_user where business_id = #{businessId} and del_flag != 1 and flag =1 and corp_id = #{corpId}")
    String getUserValue(@Param("corpId") String corpId, @Param("businessId") String businessId);

    /**
     * 更新s_user表中value
     * @param personId
     * @return
     */
    @Update("<script> update s_user set \n" +
            "`value`= " +
            "((select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 0 and person_id = #{personId}) ,0 )) -  " +
            " (select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 1 and person_id = #{personId}) ,0 )))" +
            ", lock_num = lock_num+1  " +
            "where business_id = #{personId}" +
            "<if test=\" lockNum !=null \"> and lock_num = #{lockNum} </if> "+
            "</script>")
    int updateUserValue(@Param("personId")String personId,@Param("lockNum")Integer lockNum);

    /**
     * 判断当前积分是否大于扣除积分
     * @param personId
     * @param value
     * @return
     */
    @Select("SELECT ((select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 0 and person_id =  #{personId}) ,0 )) -" +
            "(select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 1 and person_id =  #{personId}) ,0 ))) - #{value}")
    Long judgeUserValue(@Param("personId")String personId,@Param("value")String value);

    /**
     * 插入数据
     * @param bPersonValue
     * @return
     */
    @Insert("INSERT INTO b_person_value  " +
            "( remarks,create_by,create_date,update_by,update_date,del_flag,flag,business_id,person_id,`event`,`value`,type ,lesson_id)" +
            " VALUES( #{remarks},#{createBy},#{createDate},#{updateBy},#{updateDate},#{delFlag},#{flag},#{businessId},#{personId},#{event},#{value},#{type} ,#{lessonId})")
    int add(BPersonValue bPersonValue);

    /**
     * 查询用户重新统计的积分
     * @param personId
     * @return
     */
    @Select("SELECT ((select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 0 and person_id =  #{personId}) ,0 )) -" +
            "(select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 1 and person_id =  #{personId}) ,0 ))) ")
    Long findUserValue(@Param("personId")String personId);
}

