package org.rcisoft.business.breleasevalue.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import java.util.List;

@Data
public class ReleaseValueResDto {

    @ApiModelProperty(value = "分组标题")
    @Length(max = 50,message = "长度最大为50")
    public String title;

    @ApiModelProperty(value = "人员姓名")
    @Length(max = 50,message = "长度最大为50")
    public String name;

    @ApiModelProperty(value = "课程奖励起始")
    @Length(max = 10,message = "长度最大为10")
    public String lessonValueStart;

    @ApiModelProperty(value = "课程奖励截止")
    @Length(max = 10,message = "长度最大为10")
    public String lessonValueEnd;

    @ApiModelProperty(value = "培训奖励起始")
    @Length(max = 10,message = "长度最大为10")
    public String trainValueStart;

    @ApiModelProperty(value = "培训奖励截止")
    @Length(max = 10,message = "长度最大为10")
    public String trainValueEnd;

    @ApiModelProperty(value = "课程积分排序 0正序 1倒序")
    public String lessonSort;

    @ApiModelProperty(value = "培训积分排序 0正序 1倒序")
    public String trainSort;

    @ApiModelProperty(value = "更新时间排序 0正序 1倒序")
    public String timeSort;

    @ApiModelProperty(value = "企业id")
    public String corpId;

    @ApiModelProperty(value = "不用传")
    public String id;

    @ApiModelProperty(value = "不用传")
    public List<String> ids;

}
