package org.rcisoft.business.brstudentchapter.controller;


/*固定导入*/
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.blesson.entity.BLessonPerson;
import org.rcisoft.business.blesson.util.LessonSyncUtil;
import org.rcisoft.business.brstudentchapter.dto.BRStudentChapterDto;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.exception.ServiceException;
import javax.validation.Valid;


import org.rcisoft.business.brstudentchapter.entity.BRStudentChapter;
import org.rcisoft.business.brstudentchapter.service.BRStudentChapterService;

import java.util.List;
import java.util.Map;

/**
* Created by  on 2019-9-25 10:01:43.
*/
@Api(tags = "12 学生章节")
@RestController
@RequestMapping("brstudentchapter")
public class BRStudentChapterController extends PaginationController<BRStudentChapter> {

    @Autowired
    private BRStudentChapterService bRStudentChapterServiceImpl;


    @ApiOperation(value="1201 添加/更新学生端观看章节进度", notes="添加/更新")
    @PostMapping(value = "/add")
    public Result addOrUpdate(CurUser curUser, @Valid BRStudentChapterDto brStudentChapterDto, BindingResult bindingResult) {
        brStudentChapterDto.setStudentId(curUser.getUserId());
        Map map = bRStudentChapterServiceImpl.save(brStudentChapterDto, curUser);
        LessonSyncUtil.removeSynUserDTO(brStudentChapterDto.getStudentId());
        return Result.builder( new PersistModel(1),
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
               map );
    }

}
