package org.rcisoft.core.result;

import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.annotation.JsonView;
import org.rcisoft.core.model.PersistModel;

/**
 * 统一API响应结果封装
 */
public class Result {

    private int code;
    private String message;
    private Object data;

    /**
     *
     * @param dataModel
     * @param sucMessage
     * @param errMessage
     * @param data
     * @return
     */
    public static Result builder(PersistModel dataModel,String sucMessage,String errMessage,Object data){
        Result result = new Result();
        if(dataModel.isSuccessBySinglePersist())
            result.setSucessMessage(sucMessage,data);
        else
            result.setErrorMessage(errMessage,data);
        return result;
    }


    /**
     *
     * @param code
     * @param message
     * @param data
     * @return
     */
    public static Result builder(Integer code,String message,Object data){
        Result result = new Result();
        result.setCode(code);
        result.setMessage(message);
        result.setData(data);
        return result;
    }


    public void setErrorMessage(String message, Object data) {
        this.code = ResultCode.FAIL.getCode();
        this.message = message;
        this.data = data;
    }

    public void setSucessMessage(String message, Object data) {
        this.code = ResultCode.SUCCESS.getCode();
        this.message = message;
        this.data = data;
    }

    public interface DefulatJsonView{}


    public Result setCode(ResultCode resultCode) {
        this.code = resultCode.getCode();
        return this;
    }

    @JsonView(DefulatJsonView.class)
    public int getCode() {
        return code;
    }

    public Result setCode(int code) {
        this.code = code;
        return this;
    }

    @JsonView(DefulatJsonView.class)
    public String getMessage() {
        return message;
    }

    public Result setMessage(String message) {
        this.message = message;
        return this;
    }

    @JsonView(DefulatJsonView.class)
    public Object getData() {
        return data;
    }

    public Result setData(Object data) {
        this.data = data;
        return this;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}
