package org.rcisoft.sys.role.service;



import org.rcisoft.business.bdictionary.entity.BDictionary;
import org.rcisoft.business.blesson.dto.RoleTypeDepartDTO;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.dept.entity.DeptRole;
import org.rcisoft.sys.role.dto.*;
import org.rcisoft.sys.role.entity.SysRole;
import org.rcisoft.sys.user.bean.CurUser;

import java.text.ParseException;
import java.util.List;

/**
 * Created by lcy on 16/7/30.
 */
public interface SysRoleService {

    /**
     * 保存
     * @param addOrUpdateRoleDTO
     * @return
     */
    int persistRole(AddOrUpdateRoleDTO addOrUpdateRoleDTO);

    PersistModel updateRoleData(SysRole sysRole);


    /**
     * 删除
     * @param id
     * @return
     */
    int removeRole(String id);
    
    /**
     * getByid
     */
    SysRole queryRoleById(String id);
    /**
     * 分页查询角色
     * @param pageUtil
     * @param corpId
     * @return
     */
    List<SysRole> queryRolesByPagination(PageUtil pageUtil, String corpId);


    List<SysRole> queryRolesAll(String corpId);

    //select 
    List<SysRole> queryRolesSelect(SysRole sysRole);

    /**
     * 授权(赋予角色 权限)
     * @param roleId
     * @param role_menus
     * @return
     */
    PersistModel doAuthorization(String roleId, String role_menus);
    
    PersistModel doAuthorizationDept(String roleId, String role_menus);
    /**
     * 分页查询角色   根据 userId   进行checked
     * @param paginationUtility
     * @param userId
     * @param sysRole
     * @return
     */
    List<DeptRole> queryUserRolesByPagination(PageUtil<SysRole> paginationUtility, String userId, SysRole sysRole);

    /**
     *
     * @param paginationUtility
     * @param DeptId
     * @param sysRole
     * @return
     */
    List<SysRole> queryDeptRolesByPagination(PageUtil<SysRole> paginationUtility, String DeptId, SysRole sysRole);

    int queryAdminInCorp(String corpId);

    int addAdminRoleMenuUser(CurUser curUser);

    List<RoleTypeDepartDTO> queryRoleTypeByUserId(CurUser curUser);

    int initDictionary();

    int initBMessage(CurUser curUser);

    int synAll(CurUser curUser) throws ParseException;

}
