package org.rcisoft.sys.user.service;


import org.rcisoft.common.util.feignDto.MTUserInfoRspDTO;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.sys.user.dto.QueryMenuResDTO;
import org.rcisoft.sys.menu.entity.SysMenu;
import org.rcisoft.sys.user.bean.CurUser;
import org.rcisoft.sys.user.dto.QuerySysUserDTO;
import org.rcisoft.sys.user.dto.MyInfoDTO;
import org.rcisoft.sys.user.entity.SysUser;

import java.text.ParseException;
import java.util.List;
import java.util.Map;

public interface SysUserService {


    void updateUser(SysUser user, String uid, int line);

    String checkPassword(String userId);


    List<SysUser> queryUsersByPagination(PageUtil pageUtil, QuerySysUserDTO dto);

    int removeUser(String id);

    int AssignRoles(String userId,String roleId);

    int stopOrStartUserByUserBusinessId(String businessId);

    int stopUserByUserBusinessId(String businessId);

    int startUserByUserBusinessId(String businessId);

    List<SysMenu> queryUserMenus(CurUser user);

    Object queryMenusById(CurUser curUser, String modelId,String type);

    SysUser getUserState(String id);

    Object queryAllRoleById(CurUser curUser);

    Map<String,Object> queryAllDepart();

    int insertOrUpdateList(List<SysUser> sysUserList);

    int synchronizedUsers(String corpId) throws ParseException;

    /**
     * zhangqingle
     * 我的智学也查询个人信息及课程、培训、考试数量
     * @param curUser
     * @return
     */
    MyInfoDTO queryMyInfo(CurUser curUser);

    MyInfoDTO queryMyName(CurUser curUser);

    List<MTUserInfoRspDTO> getName(CurUser curUser);

    List<SysUser> test(QuerySysUserDTO dto);

    MyInfoDTO getNameById(String id);
}
